local LrPathUtils=import"LrPathUtils"local LrFtp=import"LrFtp"local LrFileUtils=import"LrFileUtils"local LrErrors=import"LrErrors"local LrDialogs=import"LrDialogs"local LrLogger=import"LrLogger"local LrHttp=import"LrHttp"local LrMD5=import"LrMD5"local LrApplication=import"LrApplication"local LrTasks=import"LrTasks"local LrStringUtils=import"LrStringUtils"require"Info"require"GalleryLRDialogues"function deleteLogFile()local logPath=LrPathUtils.child(LrPathUtils.getStandardFilePath("documents"),"GFLR.log")if LrFileUtils.exists(logPath)then local success,reason=LrFileUtils.delete(logPath)if not success then logger:error("Error deleting existing logfile!"..reason)end end end function loglog(value,level)if(logger==nil)then logger=LrLogger("GFLR")logger:enable("logfile")end if type(value)=="table"then logger:infof("%d: value is table",level);for k,v in pairs(value)do logger:infof("%d: key is  %s",level+1,k)loglog(v,level+1);end else logger:infof("%d: value = %s",level,value);end end function log(debug,value)if debug then loglog(value,0);end end function valueNoGood(value)if value==nil or value==""then return true end return false end function Strip_Control_and_Extended_Codes(str)local s=""for i=1,str:len()do if str:byte(i)>=32 and str:byte(i)<=126 then s=s..str:sub(i,i)else s=s.."?"end end return s end function addHeader(photo,headers,tag,name1,name2,debug)local v=photo:getFormattedMetadata(name1)if valueNoGood(v)and name2~=nil then v=photo:getFormattedMetadata(name2)end if not valueNoGood(v)then table.insert(headers,{field="64."..tag,value=LrStringUtils.encodeBase64(v)})end end function valueWithDefault(value,default)if valueNoGood(value)then return default end return value end function twoValuesWithDefault(value1,value2,default)if valueNoGood(value1)and valueNoGood(value2)then return default end if valueNoGood(value1)then return value2 end return value1 end function getError(result,hdrs)if hdrs.error~=nil then return hdrs.error.name end if hdrs.status~=200 then if result==nil or result==""then return"Server response ("..hdrs.status.."): "..hdrs.statusDes else return"Server response ("..hdrs.status.."): "..result end end return nil;end function processRenderedPhotos(functionContext,exportContext)local exportSession=exportContext.exportSession local exportParams=exportContext.propertyTable deleteLogFile()log(exportParams.debug," ************** session ************** ")log(exportParams.debug,_PLUGIN.id)log(exportParams.debug,version())local nPhotos=exportSession:countRenditions()log(exportParams.debug,nPhotos.." images")local progressScope=exportContext:configureProgress{title=nPhotos>1 and LOC("$$$/FtpUpload/Upload/Progress=Uploading ^1 photos to iPad",nPhotos)or LOC"$$$/FtpUpload/Upload/Progress/One=Uploading one photo to iPad",}local failures={}for index,rendition in exportContext:renditions{stopIfCanceled=true}do log(exportParams.debug,"------------------------------- image "..index.." -------------------------------")local success,pathOrMessage=rendition:waitForRender()if success then log(exportParams.debug," Successful rendition: "..pathOrMessage)else log(exportParams.debug," Unsuccessful rendition: "..pathOrMessage)end if progressScope:isCanceled()then break end if success then local filename=LrPathUtils.leafName(pathOrMessage)local extension=LrPathUtils.extension(pathOrMessage)local parent=LrPathUtils.parent(pathOrMessage)log(exportParams.debug,"Filename: "..filename)log(exportParams.debug,"Extension: "..extension)local fileAttr=LrFileUtils.fileAttributes(pathOrMessage)log(exportParams.debug,fileAttr)local photo=rendition.photo log(exportParams.debug,"Photo size: "..photo:getFormattedMetadata("fileSize"))log(exportParams.debug,"Photo type: "..photo:getFormattedMetadata("fileType"))log(exportParams.debug,"Photo dimensions: "..photo:getFormattedMetadata("dimensions"))local rawPhotoData=LrFileUtils.readFile(pathOrMessage)local headers={{field="plugin-version",value=version()},{field="plugin-type",value="2"},{field="image",value=index},{field="Content-Length",value=string.len(rawPhotoData)},{field="Content-Type",value="image/jpeg"},}addHeader(photo,headers,"copyright","copyright","creator",exportParams.debug)addHeader(photo,headers,"title","title","headline",exportParams.debug)addHeader(photo,headers,"caption","caption",nil,exportParams.debug)addHeader(photo,headers,"creator","creator",nil,exportParams.debug)addHeader(photo,headers,"city","creatorCity","city",exportParams.debug)addHeader(photo,headers,"country","creatorCountry","country",exportParams.debug)addHeader(photo,headers,"state","creatorStateProvince","stateProvince",exportParams.debug)addHeader(photo,headers,"date","dateCreated","dateTimeOriginal",exportParams.debug)local url="http://"..exportParams.ipadAddress.."/lightroom/"..filename log(exportParams.debug,url)result,hdrs=LrHttp.post(url,rawPhotoData,headers,"POST",10)log(exportParams.debug,"++++++++ Results  ++++++++")log(exportParams.debug,hdrs)log(exportParams.debug,result)log(exportParams.debug,type(result))log(exportParams.debug,"++++++++ Results  ++++++++")local errMsg=getError(result,hdrs)if errMsg~=nil then log(exportParams.debug,"Error with upload")table.insert(failures,filename)log(exportParams.debug,exportParams.ignoreErrors)if not exportParams.ignoreErrors then local res=LrDialogs.message("Unable to upload your image",errMsg,"critical")return end end end end if#failures>0 then local message if#failures==1 then message=LOC"$$$/FtpUpload/Upload/Errors/OneFileFailed=1 file failed to upload correctly."else message=LOC("$$$/FtpUpload/Upload/Errors/SomeFileFailed=^1 files failed to upload correctly.",#failures)end LrDialogs.message(message,table.concat(failures,"\n"))end end return{showSections={"outputSharpening","watermarking","imageSettings","fileSettings"},hidePrintResolution=true;allowFileFormats=nil,allowColorSpaces=nil,exportPresetFields={{key="ipadAddress",default=""},{key="quality",default=100},{key="debug",default=false},{key="ignoreErrors",default=false},},startDialog=GalleryLRDialogues.startDialog,sectionsForTopOfDialog=GalleryLRDialogues.sectionsForBottomOfDialog,processRenderedPhotos=processRenderedPhotos,}